;*****************************************************
;*                                             *       
;*****************************************************

;                 flag
; 0 -   /  (1/0)
; 1 -   /  (1/0)

;                 imod
; 1 -      /  (1/0)
; 2 -   /  (1/0)
; 3 -     / --- (1/0)
; 4 -       / --- (1/0)

;                 picter
; 0 -    
; 1 -    
; 2 -   
; 3 -    SEC/MI
; 4 -    ON/OFF
; 5 -    UP/dn

   ;.def  zero   = R0     ; 
   ;.def  tskn   = R1     ; 

    .def  cnt    = R11    ;
    .def  prslo  = R12    ;   
    .def  prshi  = R13    ;   
    .def  iml    = R14    ;    
	.def  imh    = R15    ;    
   ;.def  temp   = R16    ;   
   ;.def  temp1  = R17 
   ;.def  temp2  = R18 
   ;.def  temp3  = R19 
   ;.def  buton  = R20    ;  
   ;.def  flag   = R21    ;  
   ;.def  picter = R22    ; 
   ;.def  wait   = R23    ;      
   ;.def  wrdlo  = R24    ;  
   ;.def  wrdhi  = R25    ;  
    .def  imod   = R27    ; 
    .def  implo  = R28    ;   
	.def  imphi  = R29    ;   
   ; ZH:ZL -     


	 ldi   temp,high(tablcon_start2) 
	 sts   btfnhi,temp      
     ldi   temp,low(tablcon_start2)
	 sts   btfnlo,temp

	 ldi   wrdhi,high(_imh)  
     ldi   wrdlo,low(_imh)   
	 rcall ee_read_check
	 mov   imh,temp
	 ldi   wrdhi,high(_iml)  
     ldi   wrdlo,low(_iml)   
	 rcall ee_read_check
	 mov   iml,temp
	 ldi   wrdhi,high(_imod)  
     ldi   wrdlo,low(_imod)   
	 rcall ee_read_check
	 mov   imod,temp

	 in    temp,TIMSK
	 sbr   temp,1<<OCIE1A
     out   TIMSK,temp 

	 ldi   temp,10
	 sts   ind0,temp
	 sts   ind1,temp
	 sts   ind2,temp

     clr   flag
     clr   imphi
     clr   implo
     sbrs  imod,2
     movw  implo,iml
     movw  wrdlo,implo

	 clr   cnt
     clr   wait
   
     sei

main2:
	 rjmp  main2

tablcon_start2:
     inc   wait
	 cpi   wait,10
	 breq  PC+2
	 ret
	 clr   wait
     ldi   ZL,low(2*hello_tabl)  
	 ldi   ZH,high(2*hello_tabl)
	 add   ZL,cnt
     rcall show_start
	 inc   cnt
	 mov   temp,cnt
	 cpi   temp,8
	 breq  PC+2
	 ret
	 clr   picter
	 ldi   temp,high(tablcon2) 
	 sts   btfnhi,temp      
     ldi   temp,low(tablcon2)
	 sts   btfnlo,temp
	 ret

tablcon2:
     mov   wrdhi,picter
     clr   wrdlo
	 lsr   wrdhi
	 ror   wrdlo
	 lsr   wrdhi
	 ror   wrdlo
	 swap  buton
	 or    wrdlo,buton
	 clr   buton
	 ldi   ZH,high(state_table2)
	 ldi   ZL,low(state_table2)
	 add   ZL,wrdlo
	 adc   ZH,wrdhi
	 icall
     ret
	 
tmr_service:
     sbrs  flag,0
     ret
	 movw  wrdlo,prslo
	 adiw  wrdhi:wrdlo,1
	 movw  prslo,wrdlo
     sbrs  imod,4
     rjmp  mi0
     cpi   wrdlo,low(3600)
	 brne  n4
	 ldi   temp,high(3600) 
	 cpc   wrdhi,temp
	 brne  n4
	 rjmp  se0
mi0: sbrs  imod,3
     rjmp  se0
     cpi   wrdlo,low(60)
	 brne  n4
	 ldi   temp,high(60) 
	 cpc   wrdhi,temp
	 brne  n4
se0: clr   prslo
     clr   prshi
n1:  sbrc  imod,2
     rjmp  n3
     mov   temp,imphi
     or    temp,implo
     brne  PC+9
     sbr   flag,1<<1
     sbrs  imod,1
     rjmp  PC+4
     sbrs  flag,2
     sbi   PORTB,POV
     rjmp  n4
     cbi   PORTB,POV
     rjmp  n4
     sbiw  imphi:implo,1
     mov   temp,imphi
     or    temp,implo
     brne  n4
     sbr   flag,1<<1
     sbrs  imod,1
     rjmp  PC+4
     sbrs  flag,2
     sbi   PORTB,POV
     ret
     cbi   PORTB,POV
     ret

n3:  adiw  imphi:implo,1
     cp    iml,implo
     brne  n4
     cp    imh,imphi
     brne  n4
     sbiw  imphi:implo,1
     sbr   flag,1<<1
     sbrs  imod,1
     rjmp  PC+4
     sbrs  flag,2
     sbi   PORTB,POV
     ret
     cbi   PORTB,POV
n4:  ret

state_table2:
picter_ind_im_button_xx:
     rcall show_imp
     ret
     nop
save_par2:
	 mov   temp,imh
	 ldi   wrdhi,high(_imh)       
     ldi   wrdlo,low(_imh)   
     rcall ee_write_check
	 mov   temp,iml
	 ldi   wrdhi,high(_iml) 
     ldi   wrdlo,low(_iml)   
     rcall ee_write_check
	 mov   temp,imod
	 ldi   wrdhi,high(_imod)  
     ldi   wrdlo,low(_imod)   
     rcall ee_write_check
	 ret              
picter_ind_im_button_md:
     rcall set_tmr
     clr   wait
	 ldi   temp,2
     mov   picter,temp
	 ser   temp
	 sts   blncon,temp
	 sts   indcon,zero
	 movw  wrdlo,iml
 	 rcall bin_dec
	 cbr   flag,(1<<1)|(1<<0)
     nop
     nop
	 nop
	 ret
picter_ind_im_button_dn:  
     mov   temp,iml
	 or    temp,imh
	 brne  PC+2
	 ret
	 sts   indcon,zero
	 movw  wrdlo,implo
 	 rcall bin_dec
	 rcall set_tmr
	 cbr   flag,1<<0
     ret
xx1: mov   picter,temp
	 rcall start_tmr
     sbrs  imod,1
	 sbi   PORTB,POV
	 ret 
picter_ind_im_button_up:
     sbrc  flag,1
     ret
     mov   temp,iml
     or    temp,imh
     brne  PC+2
     ret
     ldi   temp,0b00001000
	 sbrc  imod,1
     ldi   temp,0
	 sts   indcon,temp
	 movw  wrdlo,implo
 	 rcall bin_dec
	 sbr   flag,1<<0
     ldi   temp,1
     rjmp  xx1
	 

picter_ind_cn_button_xx:
     sbrs  flag,1
     rjmp  PC+8
	 sts   indcon,zero
	 rcall show_on
     sbrs  imod,1
	 rcall show_off
     clr   picter
	 ret
	 movw  wrdlo,implo
 	 rcall bin_dec
     rcall blink_cnt
	 nop
	 nop
	 nop
	 ret               
picter_ind_cn_button_md:
     sbrs  flag,1
     rjmp  PC+8
	 sts   indcon,zero
	 rcall show_on
     sbrs  imod,1
	 rcall show_off
     clr   picter
	 ret
	 movw  wrdlo,implo
 	 rcall bin_dec
     rcall blink_cnt
	 nop
	 nop
	 nop
	 ret 
picter_ind_cn_button_dn:
     clr   picter
	 sts   indcon,zero
	 movw  wrdlo,implo
 	 rcall bin_dec
	 rcall stop_tmr
	 cbr   flag,1<<0
     ret
stop_tmr:
     cbi   PORTB,POV
     out   TCCR1B,zero
     out   TCNT1L,zero
     out   TCNT1H,zero
     in    temp,TIMSK	
     cbr   temp,1<<OCIE1A
     out   TIMSK,temp
     ret 
picter_ind_cn_button_up:
     sbrs  flag,1
     rjmp  PC+8
	 sts   indcon,zero
	 rcall show_on
     sbrs  imod,1
	 rcall show_off
     clr   picter
	 ret
	 movw  wrdlo,implo
 	 rcall bin_dec
     rcall blink_cnt
	 nop
	 nop
	 nop
	 ret 

picter_ust_button_xx:
     rcall blink_ust
     inc   wait   
	 cpse  wait,zero
	 ret   
	 clr   wait
     clr   picter
     rcall save_par2
     rcall set_tmr
	 sts   indcon,zero
     sts   blncon,zero
     rcall show_imp
     nop
	 nop
	 ret  
picter_ust_button_md: 
     clr   wait
	 ldi   temp,3
     mov   picter,temp
	 sts   indcon,zero
	 sts   blncon,zero
	 sbrc  imod,3
	 rjmp  show_min
     sbrc  imod,4
	 rjmp  show_hou
     rjmp  show_sec
	 nop
	 nop
	 nop
	 ret
picter_ust_button_dn:
     clr   wait
	 movw  wrdlo,iml
     push  wrdlo
     or    wrdlo,wrdhi
     pop   wrdlo
	 breq  PC+2
	 sbiw  wrdhi:wrdlo,1
	 movw  iml,wrdlo
	 rcall bin_dec
	 rcall blink_ust
	 ldi   temp,185
	 sts   blink,temp
	 nop
	 nop
	 ret
picter_ust_button_up:
     clr   wait
	 movw  wrdlo,iml
     cpi   wrdlo,low(999)
	 ldi   temp,high(999)
     cpc   wrdhi,temp
	 brcc  PC+2
	 adiw  wrdhi:wrdlo,1
	 movw  iml,wrdlo
	 rcall bin_dec
	 rcall blink_ust
	 ldi   temp,185
	 sts   blink,temp
	 nop
	 nop
	 ret

picter_sec_button_xx:
     inc   wait   
	 cpse  wait,zero
	 ret   
	 clr   wait
     clr   picter
     rcall save_par2
     rcall set_tmr
	 sts   indcon,zero
     sts   blncon,zero
     rcall show_imp
     nop
	 nop
	 nop
	 ret     
picter_sec_button_md: 
     clr   wait
	 ldi   temp,4
     mov   picter,temp
	 sts   indcon,zero
	 sbrc  imod,1
	 rjmp  PC+3
	 rcall show_off
	 ret
	 rcall show_on
	 nop
	 nop
	 nop
	 nop
	 nop
	 ret
picter_sec_button_dn:
     clr   wait
  	 sbrs  imod,3
	 rjmp  PC+4
	 cbr   imod,(1<<4)|(1<<3)
	 rcall show_sec
	 ret
     sbrs  imod,4
	 rjmp  PC+5
	 cbr   imod,1<<4
	 sbr   imod,1<<3
	 rcall show_min
	 ret
	 cbr   imod,1<<3
	 sbr   imod,1<<4
	 rcall show_hou
	 ret

picter_sec_button_up:
     clr   wait
  	 sbrs  imod,4
	 rjmp  PC+4
	 cbr   imod,(1<<4)|(1<<3)
	 rcall show_sec
	 ret
     sbrs  imod,3
	 rjmp  PC+5
	 cbr   imod,1<<3
	 sbr   imod,1<<4
	 rcall show_hou
	 ret
	 cbr   imod,1<<4
	 sbr   imod,1<<3
	 rcall show_min
	 ret

picter_pov_button_xx:
     inc   wait   
	 cpse  wait,zero
	 ret   
	 clr   wait
     clr   picter
     rcall save_par2
     rcall set_tmr
	 sts   indcon,zero
     sts   blncon,zero
     rcall show_imp
     ret
nn1: sts   ind2,temp
	 ret        
picter_pov_button_md: 
     clr   wait
	 ldi   temp,5
     mov   picter,temp
	 sts   indcon,zero
	 sbrc  imod,2
	 rjmp  show_dn
	 rjmp  show_up
show_sec:
     ldi   temp,23   ;SEC
     sts   ind0,temp
	 ldi   temp,21
	 sts   ind1,temp
	 ldi   temp,22
     rjmp  nn1  
picter_pov_button_dn:
     clr   wait
  	 sbrc  imod,1
	 rjmp  PC+4
	 sbr   imod,1<<1
	 rcall show_on
	 ret
	 cbr   imod,1<<1
	 rcall show_off
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 ret 
picter_pov_button_up:
     clr   wait
  	 sbrc  imod,1
	 rjmp  PC+4
	 sbr   imod,1<<1
	 rcall show_on
	 ret
	 cbr   imod,1<<1
	 rcall show_off
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 ret

picter_dir_button_xx:
     inc   wait   
	 cpse  wait,zero
	 ret   
	 clr   wait
     clr   picter
     rcall save_par2
     rcall set_tmr
	 sts   indcon,zero
     sts   blncon,zero
     rcall show_imp
     nop
	 nop
	 nop
	 ret        
picter_dir_button_md:   
	 clr   wait
     clr   picter
     rcall save_par2
     rcall set_tmr
	 sts   indcon,zero
     sts   blncon,zero
     rcall show_imp
	 ret
show_min:
     ldi   temp,25   ;MI
     sts   ind0,temp
	 ldi   temp,28
     rjmp  nn2
     ret  
picter_dir_button_dn:
     clr   wait
  	 sbrc  imod,2
	 rjmp  PC+4
	 sbr   imod,1<<2
	 rcall show_dn
	 ret
	 cbr   imod,1<<2
	 rcall show_up
	 ret
nn2: sts   ind1,temp
	 ldi   temp,38
	 sts   ind2,temp
	 nop
	 ret 
picter_dir_button_up:
     clr   wait
  	 sbrc  imod,2
	 rjmp  PC+4
	 sbr   imod,1<<2
	 rcall show_dn
	 ret
	 cbr   imod,1<<2
	 rcall show_up
	 ret
start_tmr:
     cbr   flag,1<<1
     ldi   temp,(1<<WGM12)|(1<<CS11)|(1<<CS10)
     out   TCCR1B,temp   
     in    temp,TIMSK	
     sbr   temp,1<<OCIE1A
     out   TIMSK,temp
     ret 

show_imp:
     mov   temp,iml
	 or    temp,imh
	 brne  si1
	 ldi   temp,19   ;---
     sts   ind0,temp
	 sts   ind1,temp
	 sts   ind2,temp
	 sts   indcon,zero
	 sts   blncon,zero
	 ret
si1: sbrs  flag,1
     rjmp  si2
	 sts   indcon,zero
	 rcall show_on
     sbrs  imod,1
	 rcall show_off
	 ret
si2: movw  wrdlo,implo
 	 rcall bin_dec
     ret

blink_cnt:
     ldi   temp,0b00011000
	 and   temp,imod
     brne  PC+2
	 ret
     lds   temp,blink
	 inc   temp
	 sbrs  imod,1
	 rjmp  bt1
	 cpi   temp,5
	 brne  bt2
     lds   temp1,indcon
	 cbr   temp1,0b00001000
	 sts   indcon,temp1
	 rjmp  bt3
bt1: cpi   temp,44
	 brne  bt2
     lds   temp1,indcon
	 cbr   temp1,0b00001000
	 sts   indcon,temp1
	 rjmp  bt3
bt2: cpi   temp,50
	 brne  bt3
	 lds   temp1,indcon
	 sbr   temp1,0b00001000
	 sts   indcon,temp1
	 clr   temp
bt3: sts   blink,temp
     ret

show_hou:
     ldi   temp,30   ;HOU
     sts   ind0,temp
	 ldi   temp,0
	 sts   ind1,temp
	 ldi   temp,36
	 sts   ind2,temp
     ret

show_on:
     ldi   temp,24   ;N
     sts   ind0,temp
	 ldi   temp,0
	 sts   ind1,temp
	 ldi   temp,10
	 sts   ind2,temp
     ret

show_off:
     ldi   temp,26   ;OFF
     sts   ind0,temp
	 ldi   temp,26
	 sts   ind1,temp
	 ldi   temp,0
	 sts   ind2,temp
     ret

show_up:
     ldi   temp,23   ;
     sts   ind0,temp
	 ldi   temp,6
	 sts   ind1,temp
	 ldi   temp,0
	 sts   ind2,temp
     ret

show_dn:
     ldi   temp,23   ;
     sts   ind0,temp
	 ldi   temp,29
	 sts   ind1,temp
	 ldi   temp,24
	 sts   ind2,temp
     ret

set_tmr:
     cbr   flag,1<<1
     cbi   PORTB,POV
     clr   prslo
	 clr   prshi
     sbrs  imod,2
     rjmp  PC+4
     clr   implo
	 clr   imphi
     ret
     movw  implo,iml
     ret

    .undef  cnt
    .undef  prslo
	.undef  prshi
    .undef  iml   
	.undef  imh  
    .undef  imod 
    .undef  implo  
	.undef  imphi  
